from django.db import models
from app.models import ItfModel
from ox.django.fields import DictField
from django.contrib.contenttypes.models import ContentType
from django.contrib.contenttypes import generic
from django.core.files.base import ContentFile

class GalleryAlbum(ItfModel):
    '''
    
    '''
    title = models.CharField(max_length=512)
    #slug = models.SlugField(unique=True)
    content_type = models.ForeignKey(ContentType)
    object_id = models.PositiveIntegerField()
    content_object = generic.GenericForeignKey('content_type', 'object_id')

    def __unicode__(self):
        return self.title

    def get_edit_url(self):
        return '/mediagallery/edit/%d' % self.id


class GalleryItem(models.Model):
    title = models.CharField(max_length=512, blank=True, null=True)
    done = models.BooleanField(default=False)
    album = models.ForeignKey(GalleryAlbum)
    data = DictField(default={})    

    def __unicode__(self):
        return self.title


class Photo(GalleryItem):
    image = models.ImageField(upload_to="upload/mediagallery/images", blank=True, null=True) #FIXME: upload to better place, with galleries having folders

    def save_chunk(self, chunk, name='data.bin'):
        if not self.done:
            if not self.image:
                self.image.save(name, ContentFile(chunk))
                self.title = name
                self.save()
            else:
                f = open(self.image.path, 'a')
                f.write(chunk)
                f.close()
            return True
        return False


class YoutubeVideo(GalleryItem):
    youtube_id = models.CharField(max_length=64)

    def __unicode__(self):
        return self.title

    def thumbnail(self):
        return "http://i.ytimg.com/vi/%s/default.jpg" % self.youtube_id


class GalleryLink(GalleryItem):
    url = models.URLField(verify_exists=False, max_length=1024)
    
#class Video(GalleryItem):
#    ...


#class YoutubeVideo(GalleryItem):
#    ...




# Create your models here.
